package expandDG;

import util.listreader.*;
import util.arrapp.Arrapp;
import lpt2dzfc.MathDefDictionary;
import org.w3c.dom.*;
import java.io.*;

public class BQuantDG2{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------
  
  static String[] dfds;
  static String[] arities;
  static String[][] data;
  static String[] leaves;
  static int[] leafArities;
  static MathDefDictionary mdd = new MathDefDictionary();
  static Node N;
  static NodeList dfn;
  static File outf;
  static FileOutputStream out, dataOut;
  static String[] tableData;
  static final String LEAFFILE = "expandDG/leaves";
  static final String QDATAFILE = "expandDG/Qdata";
  
// ----------------------------------------------------------------------------
// Main
// ----------------------------------------------------------------------------

  public static void main(String[] args) {
    if (args.length!=1) {
      System.out.println("Usage: java BQuantDG2 joblistfileNAME");
      //Just give the name, not the extension or the directory.
    } else {
      try {
        outf = new File("expandDG/"+args[0]+"Q.tex");
        out = new FileOutputStream(outf);
      } catch (IOException e) {
      }
      String chno = args[0].substring(args[0].length()-2,args[0].length());
      ListReader LR = new ListReader(QDATAFILE);
      LR.initialize();
      tableData = LR.readAll();
      LR = new ListReader(LEAFFILE);
      LR.initialize();
      leaves = LR.readAll();
      parseLeaves();
      QuantDG.leaves = leaves;
      QuantDG.leafArities = leafArities;
      QuantDG2.leaves = leaves;
      QuantDG2.leafArities = leafArities;
      LR = new ListReader("expandDG/"+args[0]+".d");
      LR.initialize();
      dfds = LR.readAll();
      data = new String[dfds.length][];
      for (int i = 0; i < dfds.length; i++) {
        data[i] = new String[8];
      }
      parseDfds();
      QuantDG qdg;
      int[] F;
      int D;
      String S;
      for (int k = 0; k < 3; k++) {
        QuantDG.mode = k;
        QuantDG.setList();
        QuantDG.init();
        for (int i = 0; i < dfds.length; i++) {
          N = mdd.lookUpDefiniens(dfds[i],arities[i]);
          dfn = N.getChildNodes();
          QuantDG.dfd = dfds[i]; QuantDG.arity = arities[i];
          QuantDG.dfn = dfn;
          try {
            QuantDG.preScan();
          } catch (Exception e) {
            e.printStackTrace();
          }
          qdg = new QuantDG();
          F = qdg.buildFunc();
          QuantDG.functions = Arrapp.append(QuantDG.functions,F);
          QuantDG.dfds = Arrapp.append(QuantDG.dfds,dfds[i]);
          String A = (arities[i].equals("infix")?"2":arities[i]);
          QuantDG.arities = Arrapp.append(QuantDG.arities,A);
          D = QuantDG.evalAtZeros(F);
          S = Integer.toString(D);
          if (D==Integer.MAX_VALUE) {S += "+";}
          data[i][1+k] = new String(S);
        }
        QuantDG.record();
      }
      QuantDG2 qdg2;
      for (int k = 0; k < 3; k++) {
        QuantDG2.mode = k;
        QuantDG2.setList();
        QuantDG2.init();
        for (int i = 0; i < dfds.length; i++) {
          N = mdd.lookUpDefiniens(dfds[i],arities[i]);
          dfn = N.getChildNodes();
          QuantDG2.dfd = dfds[i]; QuantDG2.arity = arities[i];
          QuantDG2.dfn = dfn;
          try {
            QuantDG2.preScan();
          } catch (Exception e) {
            e.printStackTrace();
          }
          qdg2 = new QuantDG2();
          F = qdg2.buildFunc();
          QuantDG2.functions = Arrapp.append(QuantDG2.functions,F);
          QuantDG2.dfds = Arrapp.append(QuantDG2.dfds,dfds[i]);
          String A = (arities[i].equals("infix")?"2":arities[i]);
          QuantDG2.arities = Arrapp.append(QuantDG2.arities,A);
          D = QuantDG2.evalAtZeros(F);
          S = Integer.toString(D);
          if (D==Integer.MAX_VALUE) {S += "+";}
          data[i][5+k] = new String(S);
        }
        QuantDG2.record();
      }
      //Now put LPT data in data[i][0,4]
      SimpleQ sq = new SimpleQ(args[0]);
      for (int i = 0; i < dfds.length; i++) {
        data[i][0] = sq.depths[i];
        data[i][4] = sq.altdepths[i];
      }
      //
      try {
        S = "\\bigskip\n"+
            "\\begin{center}\n"+
            "\\begin{tabular}{|l|c c c c|c c c c|}\n"+
            "\\multicolumn{9}{l}{{\\bf Munkres Chapter " + chno + "}} \\\\\\hline\n"+
            "& \\multicolumn{3}{l}{{\\bf Nesting}} &\n"+
            "& \\multicolumn{3}{l}{{\\bf Alternating Nesting}} & \\\\\n"+
            "{\\bf Definiendum}\n"+
            "& LPT & $\\alpha$ & $\\mathscr{E}(\\alpha,\\varnothing)$ "+
            "& $\\mathscr{E}(\\alpha,B_0)$\n"+
            "& LPT & $\\alpha$ & $\\mathscr{E}(\\alpha,\\varnothing)$ "+
            "& $\\mathscr{E}(\\alpha,B_0)$\\\\ \\hline\n";
        out.write(S.getBytes());
        for (int i = 0; i < dfds.length; i++) {
          S = "$\\mathop{\\mathtt{"+dfds[i]+"}}$:"+arities[i]+" & "+
              data[i][0]+" & "+
              data[i][1]+" & "+
              data[i][2]+" & "+
              data[i][3]+" & "+
              data[i][4]+" & "+
              data[i][5]+" & "+
              data[i][6]+" & "+
              data[i][7]+"\\\\\n";
          out.write(S.getBytes());
        }
        S = "\\hline\n"+
            "\\end{tabular}\n"+
            "\\end{center}\n";
        out.write(S.getBytes());
      } catch (IOException e) {
      }
      for (int i = 0; i < dfds.length; i++) {
        S = "";
        for (int j = 0; j < 8; j++) {
          S += data[i][j] + (j<7?":":"");
        }
        tableData = Arrapp.append(tableData,S);
      }
      try {
        File f = new File(QDATAFILE);
        dataOut = new FileOutputStream(f);
        for (int i = 0; i < tableData.length; i++) {
          S = tableData[i] + "\n";
          dataOut.write(S.getBytes());
        }
      } catch (IOException e) {e.printStackTrace();}
    }
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  static void parseDfds() {
    //Diagnostic:
    if (dfds==null) {System.out.println("<BatchDager.java:65>dfds is null.");}
    //
    arities = new String[dfds.length];
    String L; int w;
    for (int i = 0; i < dfds.length; i++) {
      L = dfds[i]; w = -1;
      for (int j = 0; j < L.length(); j++) {
        if (L.substring(j,j+1).equals(":")) {
          w = j; break;
        }
      }
      if (w==-1) {
        System.out.println("Error: user did not supply arity for dfd: " + L + ".");
      }
      dfds[i] = L.substring(0,w);
      arities[i] = L.substring(w+1,L.length());
    }
  }
  
  static void parseLeaves() {
    if (leaves!=null) {
      leafArities = new int[leaves.length];
      String L; int w;
      for (int i = 0; i < leaves.length; i++) {
        L = leaves[i]; w = -1;
        for (int j = 0; j < L.length(); j++) {
          if (L.substring(j,j+1).equals(":")) {
            w = j; break;
          }
        }
        if (w==-1) {
          System.out.println("Error: user did not supply arity for leaf: " + L + ".");
        }
        leaves[i] = L.substring(0,w);
        leafArities[i] = Integer.parseInt(L.substring(w+1,L.length()));
      }
    }
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 