package expandDG;

import util.arrapp.Arrapp;
import expand.ArgumentLocator;
import org.w3c.dom.*;

public class LengthDG extends ListDriven {

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------
  
  static final String LFUNCS0 = "expandDG/lfuncs0";
  static final String LFUNCSA = "expandDG/lfuncsA";
  static final String LFUNCSB = "expandDG/lfuncsB";
  
  static int mode = 0;
  
  static String dfd, arity;
  static NodeList dfn;
  
  static String[] leaves;
  static int[] leafArities;
  
  static final long LIMIT = Integer.MAX_VALUE;
  
  static boolean verbose = true;
  
  static int degree = 0;
  
  int[] function;

// --------------------------------------------------------
// Main
// --------------------------------------------------------

  public static void main(String[] args) {
    list = LFUNCS0;
    init();
    dfds = Arrapp.append(dfds,"snuf");
    arities = Arrapp.append(arities,"7");
    int[] f = {2, 3, 5, 7, 11};
    functions = Arrapp.append(functions,f);
    //record();
    int N = (int) LIMIT;
    System.out.println(Integer.toString(N));
    N /= 100;
    System.out.println(Integer.toString(N));
    N = cappedMult(N,200);
    System.out.println(Integer.toString(N));
    //
    int[] H = {2, 1, 1};
    int[][] A = new int[2][];
      int[] A0 = {4, 3, 7, 8};
      int[] A1 = {5, 2, 6, 9};
    A[0] = A0; A[1] = A1;
    int[] F = compose(H,A);
    System.out.println("F: "+
                       ","+Integer.toString(F[0])+
                       ","+Integer.toString(F[1])+
                       ","+Integer.toString(F[2])+
                       ","+Integer.toString(F[3]));
  }

// --------------------------------------------------------
// Constructor
// --------------------------------------------------------

  public LengthDG() {
    function = new int[degree+1];
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------
  
  int[] buildFunc() {return buildFunc(0,dfn.getLength()-1);}
  
  int[] buildFunc(int start, int stop) {
    Element e, d; String tag, t, n, s;
    for (int i = start; i <= stop; i++) {
      e = (Element) dfn.item(i);
      tag = e.getTagName();
      if (tag.equals("text")) {
        s = e.getFirstChild().getNodeValue();
        text(s);
      } else if (tag.equals("var")) {
        t = e.getAttribute("t");
        n = e.getAttribute("n");
        var(t,n);
      } else if (tag.equals("def")) {
        int[] endpts = new int[0];
        d = (Element) dfn.item(i+1);
        if (d!=null) {
          tag = d.getTagName();
        }
        if (tag.equals("text")) {
          String u = d.getFirstChild().getNodeValue();
          if (u.equals("(") || u.equals("[")) {
            ArgumentLocator argloc = new ArgumentLocator(dfn,i+2);
            endpts = argloc.locate();
          }
        }
        s = e.getFirstChild().getNodeValue();
        int a = endpts.length/2;
        if (mode==0 || (mode==2 && searchLeaves(s,a)>=0)) {
          text(s);
        } else {
          if (endpts.length>0) {
            i = endpts[endpts.length-1]+1;
          }
          try {
            int[] F = def(s,endpts);
            function = cappedAdd(function,F);
          } catch (Exception ex) {
            ex.printStackTrace();
          }
        }
      }
    }
    return function;
  }
  
  int[] def(String s, int[] endpts) throws Exception {
    int g = endpts.length/2;
    int[][] argFuncs = new int[0][];
    LengthDG ldg;
    int[] F;
    for (int i = 0; i < g; i++) {
      ldg = new LengthDG();
      F = ldg.buildFunc(endpts[2*i],endpts[2*i+1]);
      //diag
      if (verbose) {
        System.out.println("Working on "+s+":"+Integer.toString(g));
        if (argFuncs==null) {
          System.out.println("argFuncs is null");
        }
        if (F==null) {
          System.out.println("F is null");
        }
      }
      //
      argFuncs = Arrapp.append(argFuncs,F);
    }
    int[] H = new int[0];
    int h = searchFuncs(s,g);
    if (h<0) {
      throw new Exception("Couldn't find function for "+s+":"+
                          Integer.toString(g));
    } else {
      H = functions[h];
    }
    return compose(H,argFuncs);
  }
  
  void text(String s) {
    function[degree] = cappedAdd(function[degree],s.length());
  }
  
  void var(String t, String n) {
    if (t.equals("b")) {
      function[degree] = cappedAdd(function[degree],1);
    } else {
      int N = Integer.parseInt(n);
      function[N] = cappedAdd(function[N],1);
    }
  }
  
  static int evalAtOnes(int[] F) {
    int c = 0;
    for (int i = 0; i < F.length; i++) {
      c = cappedAdd(c,F[i]);
    }
    return c;
  }
  
  static int[] compose(int[] H, int[][] A) {
    int n = degree+1;
    try {
      if (H.length-1<A.length) {
        throw new Exception("Trying to compose wrong arities!"+
                            Integer.toString(H.length-1)+" and "+
                            Integer.toString(A.length));
      }
      boolean okay = true;
      for (int i = 0; i < A.length; i++) {
        if (A[i].length!=n) {okay = false;}
      }
      if (!okay) {
        throw new Exception("Trying to compose wrong arities!");
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
    int[] F = new int[n];
    int c;
    for (int i = 0; i < n; i++) {
      c = 0;
      for (int j = 0; j < A.length; j++) {
        c = cappedAdd(c,cappedMult(H[j],A[j][i]));
      }
      F[i] = c;
    }
    F[n-1] = cappedAdd(F[n-1],H[H.length-1]);
    return F;
  }
  
  static int searchFuncs(String s, int g) {
    int location = -1;
    if (dfds!=null) {
      for (int i = 0; i < dfds.length; i++) {
        if (dfds[i].equals(s) && arities[i].equals(Integer.toString(g))) {
          location = i; break;
        }
      }
    }
    return location;
  }
  
  static int cappedAdd(int a, int b) {
    long A = (long) a;
    long B = (long) b;
    A += B;
    if (A>LIMIT) {
      return (int) LIMIT;
    } else {
      return (int) A;
    }
  }
  
  static int cappedMult(int m, int n) {
    long M = (long) m;
    long N = (long) n;
    M *= N;
    if (M>LIMIT) {
      return (int) LIMIT;
    } else {
      return (int) M;
    }
  }
  
  static int[] cappedAdd(int[] a, int[] b) {
    try {
      if (a.length!=b.length) {
        throw new Exception("Adding arrays of different lengths!");
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
    for (int i = 0; i < a.length; i++) {
      a[i] = cappedAdd(a[i],b[i]);
    }
    return a;
  }
  
  static int searchLeaves(String s, int a) {
    int location = -1;
    if (leaves!=null) {
      for (int i = 0; i < leaves.length; i++) {
        if (leaves[i].equals(s) && leafArities[i]==a) {
          location = i; break;
        }
      }
    }
    return location;
  }
  
  static void setList() {
    switch (mode) {
      case 0: list = LFUNCS0; break;
      case 1: list = LFUNCSA; break;
      case 2: list = LFUNCSB; break;
    }
  }
  
  static void preScan() throws Exception {
  /**
   * Figures out how many free variables are in the dfn, and
   * sets the length of 'function' accordingly.
   */
    int[] A = new int[0];
    Element e; String tag, t, n; int N;
    for (int i = 0; i < dfn.getLength(); i++) {
      e = (Element) dfn.item(i);
      tag = e.getTagName();
      if (tag.equals("var")) {
        t = e.getAttribute("t");
        if (t.equals("f")) {
          n = e.getAttribute("n");
          N = Integer.parseInt(n);
          A = Arrapp.union(A,N);
        }
      }
    }
    //diag
    if (verbose) {
      String L = "";
      for (int i = 0; i < A.length; i++) {
        L += (i==0?"":",");
        L += Integer.toString(A[i]);
      }
      System.out.println("Free var numbers: " + L);
    }
    //
    //Check that only consecutive numbers, starting with 0, have been
    //used:
    boolean okay = true;
    for (int i = 0; i < A.length; i++) {
      if (A[i]>=A.length) {okay = false;}
    }
    if (!okay) {
      throw new Exception("On "+dfd+":"+arity+
                          ", free vars have bad numbers!");
    } else {
      degree = A.length;
    }
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 