package graphs;

public class KmapVertex extends Vertex {

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------
  
  private boolean expanded = false;
  private boolean sidelined = false;
  private int number = -1;
  
  String dfd, arity;
  int[] parents = new int[0];
  
  int sideX, sideY;
  
  boolean justAdded = false;
  boolean newOrphan = true;

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public KmapVertex() {
  }
  
  public KmapVertex(int x, int y) {
    X = x; Y = y;
  }
  
  public KmapVertex(String t) {
    text = t;
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  boolean isOrphan() {return (parents.length==0);}

  void expand() {expanded = true;}
  
  void collapse() {expanded = false;}
  
  void sideline() {sidelined = true;}
  
  void unsideline() {sidelined = false;}
  
  boolean isExpanded() {return expanded;}
  
  boolean isSidelined() {return sidelined;}
  
  void setNumber(int n) {number = n;}
  
  int getNumber() {return number;}
  
  boolean isOver(int x, int y) {
    int w, h;
    if (size==null) {getSize();}
    w = size.width; h = size.height;
    int U = X, V = Y;
    if (sidelined) {
      U = sideX; V = sideY;
    }
    return (U<=x) && (x<=U+w) && (V-h<=y) && (y<=V);
  }
  
  boolean overlaps(KmapVertex v) {
    if (size==null) {getSize();}
    int W = size.width; int H = size.height;
    int x = v.X; int y = v.Y;
    if (v.isSidelined()) {
      x = v.sideX; y = v.sideY;
    }
    int w = v.getSize().width;
    int h = v.getSize().height;
    return (x-W<=X) && (X<=x+w) && (y-h<=Y) && (Y<=y+H);
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 