package lpt2dzfc;

public class Aterm{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  public String var = null;
  public String numeral = null;
  public FormulaBuilder term = null;

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public Aterm() {
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  public FormulaBuilder output() {
    FormulaBuilder f = new FormulaBuilder();
    if (var!=null) {
      f.addVar(var);
    }
    if (numeral!=null) {
      decimalMeaning(f, numeral);
    }
    if (term!=null) {
      f.addText("(");
      f.append(term);
      f.addText(")");
    }
    return f;
  }
  
  public void decimalMeaning(FormulaBuilder f, String n) {
    //User must define exp, mult, add, and 0 through 10. The arithmetic
    //operations must be infix functions and must have appropriate
    //precedence numbers.
    
    String exp = "Exp_{N}";
    String mult = "\\cdot_{N}";
    String add = "+_{N}";
    String[] digits = {"0_{N}", "1_{N}", "2_{N}", "3_{N}", "4_{N}",
                       "5_{N}", "6_{N}", "7_{N}", "8_{N}", "9_{N}"};
    String ten = "10_{N}";
    
    if (n.length() == 1) {
      f.addDef(digits[Integer.parseInt(n)]);
      return;
    } else {
      String m = n.substring(0,1);
      String k = n.substring(1,n.length());
      f.addDef(digits[Integer.parseInt(m)]);
      f.addText(" ");
      f.addDef(mult);
      f.addText(" ");
      f.addDef(ten);
      f.addText(" ");
      f.addDef(exp);
      f.addText(" (");
      decimalMeaning(f,Integer.toString(n.length()-1));
      f.addText(") ");
      f.addDef(add);
      f.addText(" ");
      decimalMeaning(f,k);
    }
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 