package lpt2dzfc;

import org.w3c.dom.*;

public class DefinedConcept{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  public String concept = null;
  public String arity = null;
  public FormulaBuilder[] args = new FormulaBuilder[0];
  
  public MathDefDictionary mdd = new MathDefDictionary();
  
  private boolean alreadyDefined = false;
  private String type = null;
  private Document d = null;
  
  private final int textLocation = 0;
  private final int definiendumLocation = 1;
  private final int definiensLocation = 2;
  

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public DefinedConcept(String type) {
    this.type = type;
  }
  
  public DefinedConcept(boolean dfd, String type) {
    this.type = type;
    this.alreadyDefined = !dfd;
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------
  
  public void dfd(boolean b) {
    this.alreadyDefined = !b;
  }
  
  public FormulaBuilder output() {
    if (alreadyDefined) {
      if (arity==null) {arity=Integer.toString(args.length);}
      FormulaBuilder F = new FormulaBuilder();
      //Diagnostic:
      System.out.println("<DefinedConcept.java:52>Looking up dfd: " +
                         concept + " : " + arity);
      //
      Node N = mdd.lookUpDefiniendum(concept, arity);
      //Diagnostic:
      if (N==null) {System.out.println("<DefinedConcept.java:57>Attempt to look" +
                    " up " + concept + " : " + arity + " failed and returned null.");}
      //
      F.suffixDoc(N);
      FormulaBuilder tool = new FormulaBuilder();
      return tool.plugIn(F,args);
    } else {
      FormulaBuilder f = new FormulaBuilder();
      if (type.equals("infix")) {
        f.append(args[0]);
        f.addText(" ");
        f.addDef(concept);
        f.addText(" ");
        f.append(args[1]);
      } else {
        f.addDef(concept);
        if (args.length > 0) {
          f.addText((type.equals("function")?"(":"["));
          for (int i = 0; i < args.length; i++) {
            f.append(args[i]);
            if (i!=args.length-1) {f.addText(",");}
          }
          f.addText((type.equals("function")?")":"]"));
        }
      }
      return f;
    }
  }
  
  public void wrapVars(String[] a) {
    args = new FormulaBuilder[a.length];
    for (int i = 0; i < a.length; i++) {
      args[i] = new FormulaBuilder();
      args[i].addVar(a[i]);
    }
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 