package lpt2dzfc;

public class Infixrel{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  public String defined = null;
  public String standard = null;
  public FormulaBuilder term = null;
  
  public MathDefDictionary mdd = new MathDefDictionary();
  
  private FormulaBuilder tool = new FormulaBuilder();

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public Infixrel() {
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  public FormulaBuilder output(FormulaBuilder s, FormulaBuilder t) {
    FormulaBuilder f = new FormulaBuilder();
    if (term!=null) {
      Tupler mdt = new Tupler();
      FormulaBuilder g = mdt.pair(s,t);
      f.append(g);
      f.addText(" \\in ");
      f.append(term);
    }
    if (standard!=null) {
      if (standard.equals("=")) {
        f.append(s);
        f.addText(" = ");
        f.append(t);
      }
      if (standard.equals("\\neq")) {
        f.addText("\\neg(");
        f.append(s);
        f.addText(" = ");
        f.append(t);
        f.addText(")");
      }
      if (standard.equals("\\simeq")) {
        f.append(s);
        f.addText(" \\simeq ");
        f.append(t);
      }
    }
    if (defined!=null) {
      if (defined.equals("\\in")) {
        f.append(s);
        f.addText(" \\in ");
        f.append(t);
      } else {
        DefinedConcept mddc = new DefinedConcept("relation");
        mddc.concept = defined;
        FormulaBuilder[] a = new FormulaBuilder[2];
        a[0] = s; a[1] = t;
        mddc.args = a;
        mddc.arity = "infix";
        mddc.dfd(false);
        mddc.mdd = this.mdd;
        f = mddc.output();
      }
    }
    return f;
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 