package lpt2dzfc;

public class Term{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  public FormulaBuilder maybesimple;
  public Infixfunc[] nope = null;
  public FormulaBuilder[] otherbterms = null;

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public Term() {
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  public FormulaBuilder output() {
    FormulaBuilder f = new FormulaBuilder();
    if (nope==null) {f = maybesimple;}
    else {
      //Prepare arrays:
      FormulaBuilder[] terms = new FormulaBuilder[otherbterms.length+1];
      terms[0] = maybesimple;
      System.arraycopy(otherbterms,0,terms,1,otherbterms.length);
      Infixfunc[] funcs = nope;
      //Evaluate term:
      int n;
      while (terms.length>1) {
        n = nextFunc(funcs);
        f = funcs[n].output(terms[n],terms[n+1]);
        //Shorten arrays:
        FormulaBuilder[] a = new FormulaBuilder[terms.length-1];
        System.arraycopy(terms,0,a,0,n);
        a[n] = f;
        System.arraycopy(terms,n+2,a,n+1,terms.length-(n+2));
        terms = a;
        Infixfunc[] b = new Infixfunc[funcs.length-1];
        System.arraycopy(funcs,0,b,0,n);
        System.arraycopy(funcs,n+1,b,n,funcs.length-(n+1));
        funcs = b;
      }
    }
    return f;
  }
  
  private int nextFunc(Infixfunc[] a) {
    //Determine least precedence number:
    int w = 0;
    for (int i = 1; i < a.length; i++) {
      if (a[i].compareTo(a[w])<0) {
        w = i;
      }
    }
    //Since we only change on strict less-than,
    //w already points to the earliest occurrence
    //of the least precedence number.
    return w;
  }
  
  public FormulaBuilder evaluate(FormulaBuilder F, FormulaBuilder[] a) {
  //Use this method to translate the application of a term as a function.
  //The use of a defined function string should just be translated literally,
  //since we have the same string in the system into which we are translating.
  //This method is used by Bterm and by Infixfunc.
    //Generate the var to be bound by iota:
    FormulaBuilder g = new FormulaBuilder();
    for (int i = 0; i < a.length; i++) {
      g.append(a[i]);
    }
    g.append(F);
    String preBV = g.fresh();
    FormulaBuilder bv = new FormulaBuilder();
    bv.addVar(preBV);
    //Generate the tuple:
    Tupler mdtup = new Tupler();
    FormulaBuilder[] b = new FormulaBuilder[a.length+1];
    System.arraycopy(a,0,b,0,a.length);
    b[a.length] = bv;
    FormulaBuilder tup = mdtup.tuple(b);
    FormulaBuilder f = new FormulaBuilder();
    f.addText("(\\iota ");
    f.append(bv);
    f.addText(")(");
    f.append(tup);
    f.addText(" \\in ");
    f.append(F);
    f.addText(")");
    f.bind(preBV);
    return f;
  }
  
  public void addIF(Infixfunc m) {
    if (nope==null) {
      nope = new Infixfunc[1];
      nope[0] = m;
    } else {
      Infixfunc[] a = new Infixfunc[nope.length+1];
      System.arraycopy(nope,0,a,0,nope.length);
      a[nope.length] = m;
      nope = a;
    }
  }
  
  public void addBT(FormulaBuilder g) {
    if (otherbterms==null) {
      otherbterms = new FormulaBuilder[1];
      otherbterms[0] = g;
    } else {
      FormulaBuilder[] a = new FormulaBuilder[otherbterms.length+1];
      System.arraycopy(otherbterms,0,a,0,otherbterms.length);
      a[otherbterms.length] = g;
      otherbterms = a;
    }
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 