package lpt2dzfc;

public class Termformula{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------
  
  public FormulaBuilder initial = new FormulaBuilder();
  public FormulaBuilder[] maybepred = new FormulaBuilder[0];
  public Infixrel nope = null;
  public FormulaBuilder[] mandatory = new FormulaBuilder[0];
  public Infixrel[] furtherrels = new Infixrel[0];
  public FormulaBuilder[][] furthertermseqs = new FormulaBuilder[0][];
  
  Infixrel[] infixrels;
  FormulaBuilder[][] termseqs;
  
  boolean alreadydone = false;
  FormulaBuilder out = new FormulaBuilder();

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public Termformula() {
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------
  
  public void further(Infixrel m, FormulaBuilder[] a) {
    furtherrels = concatIR(furtherrels,m);
    furthertermseqs = concatFBArray(furthertermseqs,a);
  }
  
  public void definedness(String s) {
    if (s.equals("\\downarrow")) {
      out.append(initial);
      out.addText("\\mathord{\\downarrow}");
    }
    if (s.equals("\\uparrow")) {
      out.addText("\\neg ");
      out.append(initial);
      out.addText("\\mathord{\\downarrow}");
    }
    alreadydone = true;
  }
  
  public FormulaBuilder output() {
    //Diagnostic:
    System.out.println("<Termformula.java:53>Termformula.output() has been called.");
    //
    if (!alreadydone) {
      if (nope==null) {
        //In this case it is a predication.
        Tupler mdt = new Tupler();
        FormulaBuilder f = new FormulaBuilder();
        f = mdt.tuple(maybepred);
        out.append(f);
        out.addText(" \\in ");
        out.append(initial);
      } else {
        //In this case it is a multi-infix-relation (MIR)
        //Diagnostic:
        if (mandatory==null) {System.out.println("WTF");}
        else {System.out.println("<Termformula.java:65>Length of mandatory"+
                                 " is: " + Integer.toString(mandatory.length));}
        //System.out.println("<Termformula.java:64>"+mandatory[0].toStringNaked());
        //
        prepMIRArrays();
        //Diagnostic:
        //System.out.println("<Termformula.java:68>"+termseqs[1][0].toStringNaked());
        //System.out.println("<Termformula.java:69>Length of infixrels array: "+
        //                   Integer.toString(infixrels.length));
        //System.out.println("<Termformula.java:71>Length of termseqs array: "+
        //                   Integer.toString(termseqs.length));
        //
        for (int i = 0; i < infixrels.length; i++) {
          for (int j = 0; j < termseqs[i].length; j++) {
            for (int k = 0; k < termseqs[i+1].length; k++) {
              Infixrel R = infixrels[i];
              FormulaBuilder s = termseqs[i][j];
              FormulaBuilder t = termseqs[i+1][k];
              //Diagnostic:
              if (t==null) {
                System.out.println("<Termformula.java:82>t is null.\n"+
                                   "i: " + Integer.toString(i) + "\n" +
                                   "j: " + Integer.toString(j) + "\n" +
                                   "k: " + Integer.toString(k));
              }
              //
              out.append(R.output(s,t));
              if (i<infixrels.length-1 || 
                  j<termseqs[i].length-1 || 
                  k<termseqs[i+1].length-1)
                {out.addText(" \\wedge ");}
            }
          }
        }
      }
    }
    return out;
  }
  
  void prepMIRArrays() {
    FormulaBuilder[] firstseq = new FormulaBuilder[maybepred.length+1];
    firstseq[0] = initial;
    System.arraycopy(maybepred,0,firstseq,1,maybepred.length);
    infixrels = new Infixrel[furtherrels.length+1];
    infixrels[0] = nope;
    System.arraycopy(furtherrels,0,infixrels,1,furtherrels.length);
    termseqs = new FormulaBuilder[furthertermseqs.length+2][];
    termseqs[0] = firstseq;
    termseqs[1] = mandatory;
    System.arraycopy(furthertermseqs,0,termseqs,2,furthertermseqs.length);
  }
  
  public Infixrel[] concatIR(Infixrel[] a, Infixrel m) {
    Infixrel[] b = null;
    if (a==null) {
      b = new Infixrel[1];
      b[0] = m;
    } else {
      b = new Infixrel[a.length+1];
      System.arraycopy(a,0,b,0,a.length);
      b[a.length] = m;
    }
    return b;
  }
  
  public FormulaBuilder[][] concatFBArray(FormulaBuilder[][] b,
                                          FormulaBuilder[] g) {
    FormulaBuilder[][] c = null;
    if (b==null) {
      c = new FormulaBuilder[1][];
      c[0] = g;
    } else {
      c = new FormulaBuilder[b.length+1][];
      System.arraycopy(b,0,c,0,b.length);
      c[b.length] = g;
    }
    return c;
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 